#pragma once

#include "ContainerScriptletPlugin.h"
#include "ScriptletContainerFactory.h"
#include "Application.h"

class NPCOMMONUI_API CSimpleTextScriptletPlugin : public CContainerScriptletPlugin
{
public:
	DECLARE_REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(CSimpleTextScriptletPlugin);
	CSimpleTextScriptletPlugin(void);
	virtual ~CSimpleTextScriptletPlugin(void);

//override
	BOOL ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);
	CComponent* _CreateComponent(TiXmlElement* pNode);

	virtual LPCTSTR LoadString(LPCTSTR pszID) { return Application::LoadString(pszID); }
};

class NPCOMMONUI_API CXMLTextScriptletPlugin : public CSimpleTextScriptletPlugin
{
public:
	DECLARE_REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(CXMLTextScriptletPlugin);
	CXMLTextScriptletPlugin(void) {}
	virtual ~CXMLTextScriptletPlugin(void) {}

	//override
	BOOL ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);
	CComponent* _CreateComponent(TiXmlElement* pNode);
};

class NPCOMMONUI_API CStateTextScriptletPlugin : public CSimpleTextScriptletPlugin
{
public:
	DECLARE_REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(CStateTextScriptletPlugin);
	CStateTextScriptletPlugin(void) {}
	virtual ~CStateTextScriptletPlugin(void) {}

	//override
	BOOL ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);
	CComponent* _CreateComponent(TiXmlElement* pNode);
};